#
# Makefile Template for Tessy
# Compiler: Cosmic HC11
#

# Defines to be generated by Tessy:
#
# TESSY_SYS          :=
# MODULE_PATH        :=
# TESTOBJECT         :=
# USER_LINK_OPTIONS  :=
# COMPILER_INSTALL_PATH :=
# TARGET_INSTALL_PATH   :=

#####################################################################
#BEGIN_DEFINES
#####################################################################

TESSY_SYS_DOS		:=	$(shell cygpath -w $(TESSY_SYS))
MODULE_PATH_DOS	:=	$(shell cygpath -w $(MODULE_PATH))
COSMIC_HOME			:= $(shell ts_pathname -s '$(COMPILER_INSTALL_PATH)')


all	 : master slave
master : $(MODULE_PATH)/ts_$(TESTOBJECT)_m.exe
slave  : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s.h12

#
# MASTER & COMM Makefiles
# (you should not need to modify these settings)
#
M_COMM_MAKE		:=	$(TESSY_SYS)/make/master_trace32_gnu_i386.mk
S_COMM_MAKE		:=	$(TESSY_SYS)/src/comm/comm_trace32_cosmic_hc12.mk


#
# SLAVE
# (You may change these settings to use your own compiler/linker options)
#
S_COMP_OPTIONS := +debug -dTESSY -dTS_SLAVE -dTS_TRACE32 -dTS_HAVE_FLOAT64 -dTS_HC12 -co"$(MODULE_PATH_DOS)" -t"$(MODULE_PATH_DOS)"
S_LINK_OPTIONS	:= -v -m"$(MODULE_PATH_DOS)\$(TS_TESTOBJECT)_s.map"
S_INCLUDES		:= -i$(TESSY_SYS_DOS)\include\tessy\comm -i$(MODULE_PATH_DOS)

S_CC				:=	$(COSMIC_HOME)\cx6811
S_LINK			:=	$(COSMIC_HOME)\clnk
S_OBJECTS  		:= $(MODULE_PATH_DOS)\tslows_trace32.o \
             		$(MODULE_PATH_DOS)\tstcomm.o \
             		$(MODULE_PATH_DOS)\tscoml.o
S_STUB_OBJECT  := $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_stubs.o
S_UC_OBJECT    := $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_usr.o


#####################################################################
#END_DEFINES
#####################################################################

# Targets to be defined by Tessy
#
# for each source
#
# S_SRC_OBJECTS      := $(MODULE_PATH)/ts_src01.o ... ts_srcnn.o
# USER_COMP_OPTIONS* :=
# S_C1_OBJECTS       := $(MODULE_PATH)/ts_c1c01.o ... ts_c1cnn.o
#
# $(MODULE_PATH)/ts_src*.o : $(MODULE_PATH)/ts_src*.c
#     $(S_CC) $(S_INCLUDES) $(S_COMP_OPTIONS) $(USER_COMP_OPTIONS*) $<
#
# $(MODULE_PATH)/ts_c1c*.o : $(MODULE_PATH)/ts_c1c*.c
#     $(S_CC) $(S_INCLUDES) $(S_COMP_OPTIONS) $(USER_COMP_OPTIONS*) $<

#####################################################################
#BEGIN_TARGETS
#####################################################################


#
# COMPILE USERCODE / STUBS
#
$(S_UC_OBJECT) : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_usr.c
	@echo ***** Compiling Usercode *****
	$(S_CC) $(S_INCLUDES) $(S_COMP_OPTIONS) $<

$(S_STUB_OBJECT) : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_stubs.c
	@echo ***** Compiling Stubs *****
	$(S_CC) $(S_INCLUDES) $(S_COMP_OPTIONS) $<

#
# COMPILE/LINK MASTER
#

include $(M_COMM_MAKE)


#
# COMPILE SLAVE COMMUNICATION MODULES

include $(S_COMM_MAKE)



#
# COMPILE/LINK SLAVE
#
$(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s.o : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s.c
	@echo *
	@echo ***** Compiling Slave *****
	$(S_CC) $(S_COMP_OPTIONS) $(S_INCLUDES) $<

$(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s.h12 : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s.o \
															$(S_SRC_OBJECTS) \
															$(S_UC_OBJECT) \
															$(S_STUB_OBJECT) \
															$(S_C1_OBJECTS) \
															$(S_OBJECTS) \
															$(MODULE_PATH_DOS)\vector_cosmic_hc12.o
	@echo *
	@echo ***** Linking Slave *****
	@echo +seg .text -b $(BEGIN_CODE) -nCODE  -sROM	# program start address    > $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lkf
	@echo +seg .const -aCODE   -nCONST  -it -sROM                              >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lkf
	@echo +seg .bsct -b $(BEGIN_DATA) -nZPAGE -m0xFF -sRAM -ib # zero page start address >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lkf
	@echo +seg .data -a ZPAGE -nIDATA -m0x200 -sRAM	# data start address       >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lkf
	@echo +seg .bss  -aIDATA  -nUDATA -sRAM                                    >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lkf
	@echo $(COSMIC_HOME)\LIB\crtsi.h11 >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lkf
	@sh -c 'for f in $(S_SRC_OBJECTS); do echo "$$f" >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lkf; done'
	@echo $(S_UC_OBJECT) >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lkf
	@echo $(S_STUB_OBJECT) >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lkf
	@echo $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s.o >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lkf
	@echo $(MODULE_PATH_DOS)\tslows_trace32.o >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lkf
	@echo $(MODULE_PATH_DOS)\tstcomm.o >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lkf
	@echo $(MODULE_PATH_DOS)\tscoml.o >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lkf
	@echo $(USER_LINK_OPTIONS) #USER_LINK_OPTIONS  >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lkf
	@echo $(COSMIC_HOME)\LIB\libi.h11 >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lkf
	@echo $(COSMIC_HOME)\LIB\libm.h11 >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lkf
	@echo +seg .const -b $(BEGIN_IRVTAB) >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lkf
	@echo $(MODULE_PATH_DOS)\vector_cosmic_hc12.o >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lkf
	@echo +def __memory=@.bss >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lkf
	@echo +def __stack=$(BEGIN_STACK) >> $(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lkf

	$(S_LINK) -o "$@" $(S_LINK_OPTIONS) \
				"$(MODULE_PATH_DOS)\ts_$(TESTOBJECT).lkf"
	@-rm "$(MODULE_PATH)"/*.o

#####################################################################
#END_TARGETS
#####################################################################












